#!/usr/bin/perl
#
# Convert a binary file to BASIC POKE
#

use bytes;

($file, $org, $nl, $el) = @ARGV;

$org = oct $org if ( $org =~ /^0/ );

$nl -= 1 if ( $nl > 0 );
$ln = '';

open(FILE, '<:raw', $file) or die "$0: $file: $!\n";

while ( ($l = read(FILE, $dd, 65536)) > 0 ) {
    for ( $i = 0 ; $i < $l ; $i++ ) {
	$c = ord(substr($dd,$i,1));
	if ( $ln ne '' && length($ln.','.$c.'%') > 74 ) {
	    print $ln, "\n";
	    $ln = '';
	}
	if ( $ln eq '' ) {
	    $nl++;
	    $ln = sprintf("%u POKE %u%%", $nl, $org);
	}
	$ln .= ','.$c.'%';
	$org++;
    }
}

if ( $ln ne '' ) {
    print $ln, "\n";
}

if ( defined($el) ) {
    $nl++;
    print $nl, ' ', $el, "\n";
}

close(FILE);

exit 0;
